//
// Core Foundation
//
// Provides access to select portions of Apple's Core Foundation
// framework from JavaScript using js-ctypes.
//

// First, import the Core Foundation library.

Components.utils.import("resource://gre/modules/ctypes.jsm");    

var CoreFoundation = {
  lib: null,      /* The Core Foundation library reference */
  
  init: function() {
    this.lib = ctypes.open("/System/Library/Frameworks/CoreFoundation.framework/CoreFoundation");
    
    // CFMutableArray
    
    this.CFMutableArrayRef = new ctypes.PointerType("CFMutableArrayRef"),
    
    this.CFArrayCreateMutable = lib.declare("CFArrayCreateMutable",
                                ctypes.default_abi,
                                CFArrayRef,               // returns an array
                                ctypes.voidptr_t,         // allocator
                                ctypes.int32_t,           // capacity
                                ctypes.voidptr_t);        // CFArrayCallbacks *callbacks
  },
  
  shutdown: function() {
    this.lib.close();
  }
}
